module Eval where

import Parse
import Types
import qualified Data.Map as M
import Control.Monad.State

type Env = M.Map String Value

type Running = StateT Env IO

-- getVar v extracts the value of the variable named v from the environment
getVar :: String -> Running Value
-- You write this one.
                   
--------------------------------------------------------------------------------------------

evalStmt :: Statement -> Running ()
-- You write this one.

--------------------------------------------------------------------------------------------

evalExpr :: Expression -> Running Value
-- You write this one.

--------------------------------------------------------------------------------------------

runString s = evalStateT (evalStmt $ parseString s) M.empty

runFile f =
    do s <- parseFile f
       evalStateT (evalStmt s) M.empty
